# mypy-boto3-fsx<a id="mypy-boto3-fsx"></a>

[![PyPI - mypy-boto3-fsx](https://img.shields.io/pypi/v/mypy-boto3-fsx.svg?color=blue)](https://pypi.org/project/mypy-boto3-fsx)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-fsx.svg?color=blue)](https://pypi.org/project/mypy-boto3-fsx)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-fsx?color=blue)](https://pypistats.org/packages/mypy-boto3-fsx)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.FSx 1.17.82](https://boto3.amazonaws.com/v1/documentation/api/1.17.82/reference/services/fsx.html#FSx)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.14.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-fsx docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_fsx/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-fsx](#mypy-boto3-fsx)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

## How to install<a id="how-to-install"></a>

Install `boto3-stubs` for `FSx` service.

```bash
python -m pip install boto3-stubs[fsx]
```

## Usage<a id="usage"></a>

### VSCode<a id="vscode"></a>

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[fsx]` in your environment:
  `python -m pip install 'boto3-stubs[fsx]'`

Both type checking and auto-complete should work for `FSx` service. No explicit
type annotations required, write your `boto3` code as usual.

### PyCharm<a id="pycharm"></a>

- Install `boto-stubs[fsx]` in your environment:
  `python -m pip install 'boto3-stubs[fsx]'`

Both type checking and auto-complete should work for `FSx` service. No explicit
type annotations required, write your `boto3` code as usual. Auto-complete can
be slow on big projects or if you have a lot of installed `boto3-stubs`
submodules.

### Other IDEs<a id="other-ides"></a>

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

### mypy<a id="mypy"></a>

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[fsx]` in your environment:
  `python -m pip install 'boto3-stubs[fsx]'`
- Run `mypy` as usual

Type checking should work for `FSx` service. No explicit type annotations
required, write your `boto3` code as usual.

### pyright<a id="pyright"></a>

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[fsx]` in your environment:
  `python -m pip install 'boto3-stubs[fsx]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `FSx` service. No explicit type annotations
required, write your `boto3` code as usual.

## Explicit type annotations<a id="explicit-type-annotations"></a>

### Client annotations<a id="client-annotations"></a>

`FSxClient` provides annotations for `boto3.client("fsx")`.

```python
import boto3

from mypy_boto3_fsx import FSxClient

client: FSxClient = boto3.client("fsx")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: FSxClient = session.client("fsx")
```

### Paginators annotations<a id="paginators-annotations"></a>

`mypy_boto3_fsx.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_fsx import FSxClient
from mypy_boto3_fsx.paginator import (
    DescribeBackupsPaginator,
    DescribeFileSystemsPaginator,
    ListTagsForResourcePaginator,
)

client: FSxClient = boto3.client("fsx")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
describe_backups_paginator: DescribeBackupsPaginator = client.get_paginator("describe_backups")
describe_file_systems_paginator: DescribeFileSystemsPaginator = client.get_paginator("describe_file_systems")
list_tags_for_resource_paginator: ListTagsForResourcePaginator = client.get_paginator("list_tags_for_resource")
```

### Literals<a id="literals"></a>

`mypy_boto3_fsx.literals` module contains literals extracted from shapes that
can be used in user code for type checking.

```python
from mypy_boto3_fsx.literals import (
    AdministrativeActionTypeType,
    AliasLifecycleType,
    AutoImportPolicyTypeType,
    BackupLifecycleType,
    BackupTypeType,
    DataRepositoryLifecycleType,
    DataRepositoryTaskFilterNameType,
    DataRepositoryTaskLifecycleType,
    DataRepositoryTaskTypeType,
    DescribeBackupsPaginatorName,
    DescribeFileSystemsPaginatorName,
    DriveCacheTypeType,
    FileSystemLifecycleType,
    FileSystemMaintenanceOperationType,
    FileSystemTypeType,
    FilterNameType,
    ListTagsForResourcePaginatorName,
    LustreDeploymentTypeType,
    ReportFormatType,
    ReportScopeType,
    StatusType,
    StorageTypeType,
    WindowsDeploymentTypeType,
)

def check_value(value: AdministrativeActionTypeType) -> bool:
    ...
```

### Typed dictionaries<a id="typed-dictionaries"></a>

`mypy_boto3_fsx.type_defs` module contains structures and shapes assembled to
typed dictionaries for additional type checking.

```python
from mypy_boto3_fsx.type_defs import (
    ActiveDirectoryBackupAttributesTypeDef,
    AdministrativeActionFailureDetailsTypeDef,
    AdministrativeActionTypeDef,
    AliasTypeDef,
    AssociateFileSystemAliasesResponseTypeDef,
    BackupFailureDetailsTypeDef,
    BackupTypeDef,
    CancelDataRepositoryTaskResponseTypeDef,
    CompletionReportTypeDef,
    CopyBackupResponseTypeDef,
    CreateBackupResponseTypeDef,
    CreateDataRepositoryTaskResponseTypeDef,
    CreateFileSystemFromBackupResponseTypeDef,
    CreateFileSystemLustreConfigurationTypeDef,
    CreateFileSystemResponseTypeDef,
    CreateFileSystemWindowsConfigurationTypeDef,
    DataRepositoryConfigurationTypeDef,
    DataRepositoryFailureDetailsTypeDef,
    DataRepositoryTaskFailureDetailsTypeDef,
    DataRepositoryTaskFilterTypeDef,
    DataRepositoryTaskStatusTypeDef,
    DataRepositoryTaskTypeDef,
    DeleteBackupResponseTypeDef,
    DeleteFileSystemLustreConfigurationTypeDef,
    DeleteFileSystemLustreResponseTypeDef,
    DeleteFileSystemResponseTypeDef,
    DeleteFileSystemWindowsConfigurationTypeDef,
    DeleteFileSystemWindowsResponseTypeDef,
    DescribeBackupsResponseTypeDef,
    DescribeDataRepositoryTasksResponseTypeDef,
    DescribeFileSystemAliasesResponseTypeDef,
    DescribeFileSystemsResponseTypeDef,
    DisassociateFileSystemAliasesResponseTypeDef,
    FileSystemFailureDetailsTypeDef,
    FileSystemTypeDef,
    FilterTypeDef,
    ListTagsForResourceResponseTypeDef,
    LustreFileSystemConfigurationTypeDef,
    PaginatorConfigTypeDef,
    SelfManagedActiveDirectoryAttributesTypeDef,
    SelfManagedActiveDirectoryConfigurationTypeDef,
    SelfManagedActiveDirectoryConfigurationUpdatesTypeDef,
    TagTypeDef,
    UpdateFileSystemLustreConfigurationTypeDef,
    UpdateFileSystemResponseTypeDef,
    UpdateFileSystemWindowsConfigurationTypeDef,
    WindowsFileSystemConfigurationTypeDef,
)

def get_structure() -> ActiveDirectoryBackupAttributesTypeDef:
    return {
      ...
    }
```

## Versioning<a id="versioning"></a>

`mypy-boto3-fsx` version is the same as related `boto3` version and follows
[PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

## Documentation<a id="documentation"></a>

All type annotations can be found in
[mypy-boto3-fsx docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_fsx/)

## Support and contributing<a id="support-and-contributing"></a>

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
